Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollectionManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SuperCollectionManager.java	(revision 4932)
@@ -28,17 +28,21 @@
 
 import java.awt.*;
-import java.awt.event.*;
 import java.io.*;
 import java.util.*;
 import javax.swing.*;
+import javax.swing.event.*;
 import org.greenstone.gatherer.Configuration;
 import org.greenstone.gatherer.Dictionary;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.checklist.CheckList;
 import org.greenstone.gatherer.checklist.Entry;
 import org.greenstone.gatherer.collection.CollectionConfiguration;
+import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
-
-public class SuperCollectionManager {
+import org.w3c.dom.*;
+/** This class contains the information about what supercollection has been specified (if any) and methods for changing this information. Note that there is a major difference between this manager and the others in that its DOM model is never used directly in any list component. It is only used to decide whether a certain entry in the actual checklist is checked. */
+public class SuperCollectionManager 
+    extends DOMProxyListModel {
 
     static final public String SUPERCOLLECTION_COMMAND = "supercollection";
@@ -46,113 +50,55 @@
 
     private String current_coll_name = null;
-    private Control controls;
-    private ArrayList collection_checklist_model;
-
-    SuperCollectionManager() {
-	// We start by building a model of the installed collections.
-	collection_checklist_model = new ArrayList();
-	File gsdl_collection_directory = new File(Utility.getCollectionDir(Gatherer.config.gsdl_path));
-	current_coll_name = Gatherer.c_man.getCollection().getName();
-	File[] possible_collections = gsdl_collection_directory.listFiles();
-	for(int i = 0; possible_collections != null && i < possible_collections.length; i++) {
-	    // The simpliest case is if the directory etc/collect.cfg file and a metadata/ in it. Thus it can easily be built upon.
-	    File collect_cfg_file = new File(possible_collections[i], Utility.CONFIG_DIR);
-	    if(collect_cfg_file.exists()) {
-		CollectionConfiguration collect_cfg = new CollectionConfiguration(collect_cfg_file);
-		String collection_title = collect_cfg.getName();
-		String collection_name = possible_collections[i].getName();
-		// We do have to block the model collection.
-		if(!collection_title.equals("**title**")) {
-		    Entry entry = new Entry(collection_title);
-		    entry.setProperty(collection_name);
-		    if (collection_name.equals(current_coll_name)) {
-			// the current collection is always selected
-			entry.setFixed(true);
-			entry.setSelected(true);
-		    }
-		    collection_checklist_model.add(entry);
-		    entry = null;
-
-		}
-		collection_name = null;
-		collection_title = null;
-		collect_cfg = null;
+    private Control controls = null;
+    private ArrayList collection_checklist_model = null; // Model used to actually populate list
+
+    public SuperCollectionManager(Element supercollections_element) {
+	super(supercollections_element, StaticStrings.COLLECTION_ELEMENT, new SuperCollection());
+	Gatherer.println("SuperCollectionManager: " + getSize() + " supercollection members parsed.");
+    }
+
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	if(collection_checklist_model != null) {
+	    collection_checklist_model.clear();
+	    collection_checklist_model = null;
+	}
+    }
+
+    public void addSuperCollection(SuperCollection supercollection) {
+	if(!contains(supercollection)) {
+	    add(getSize(), supercollection);
+	}
+    }
+
+    /** Method to retrieve the control for this manager.
+     * @return the Control for editing supercollection settings
+     */
+    public Control getControls() {
+	if(controls == null) {
+	    // Build controls
+	    this.controls = new SuperCollectionControl();
+	}
+	return controls;
+    }
+
+    public SuperCollection getSuperCollection(String collection_name) {
+	SuperCollection result = null;
+	int size = getSize();
+	for(int i = 0; result == null && i < size; i++) {
+	    SuperCollection supercollection = (SuperCollection) getElementAt(i);
+	    if(supercollection.getName().equals(collection_name)) {
+		result = supercollection;
 	    }
-	    collect_cfg_file = null;
-	}
-	possible_collections = null;
-	gsdl_collection_directory = null;
-	// Sort the result.
-	Collections.sort(collection_checklist_model);
-    }
-
-    public boolean parse(String command) {
-	String command_lc = command.toLowerCase();
-	if(command_lc.startsWith(SUPERCOLLECTION_COMMAND) || command_lc.startsWith(CCS_COMMAND)) {
-	    StringTokenizer tokenizer = new StringTokenizer(command);
-	    tokenizer.nextToken();
-	    // Read in each of the collection names.
-	    ArrayList collection_names = new ArrayList();
-	    while(tokenizer.hasMoreTokens()) {
-		collection_names.add(tokenizer.nextToken());
-	    }
-	    // Now that we have the collection names, select any entries in the checklist that match.
-	    for(int i = 0; i < collection_checklist_model.size(); i++) {
-		Entry entry = (Entry) collection_checklist_model.get(i);
-		String collection_name = entry.getProperty();
-		if(collection_names.contains(collection_name)) {
-		    entry.setSelected(true);
-		    collection_names.remove(collection_name); // Makes successive runs faster.
-		}
-		collection_name = null;
-		entry = null;
-	    }
-	    // Done.
-	    return true;
-	}
-	return false;
-    }
-
-    /** Method to retrieve the control for this manager.
-     * @return A JPanel containing the controls.
-     */
-    public JPanel getControls() {
-	if(controls == null) {
-	    controls = new Control();
-	}
-	return controls;
-    }
-
-    public void invalidateControls() {
-	controls = null;
-    }
-
-    /** Return the contents of this manager as a command or block of commands ready to be written to the collection configuration file. 
-     * @return A String containing a configuration command or block of commands, terminated with a new line. This value will be null if there was no supercollection command set. */
-    public String toString() {
-	StringBuffer command = new StringBuffer(SUPERCOLLECTION_COMMAND);
-	// Now for each entry selected output its collection name (property setting)
-	boolean found_entry = false;
-	for(int i = 0; i < collection_checklist_model.size(); i++) {
-	    Entry entry = (Entry) collection_checklist_model.get(i);
-	    if(entry.isSelected()) {
-		if (!entry.getProperty().equals(current_coll_name)){
-		    found_entry = true;
-		}
-		command.append(" ");
-		command.append(entry.getProperty());
-	    }
-	    entry = null;
-	}
-	command.append("\n");
-	command.append("\n");
-	
-	// It is possible that there was only one entry - the current collection -  in which case we return null.
-	if(found_entry) {
-	    return command.toString();
-	}
-	else {
-	    return null;
-	}
+	    supercollection = null;
+	}
+	return result;
+    }
+
+    public void removeSuperCollection(SuperCollection supercollection) {
+	remove(supercollection);
     }
 
@@ -169,12 +115,16 @@
 
     /** Provides controls for altering the SuperCollection settings. */
-    private class Control
-	extends JPanel {
+    private class SuperCollectionControl
+	extends JPanel 
+	implements Control {
 
 	private boolean init = true;
+	private CheckList collection_checklist = null;
 	//private JSplitPane center_pane;
 
-	Control() {
+	SuperCollectionControl() {
 	    super();
+
+	    buildModel();
 	    // Creation
 	    JPanel header_panel = new JPanel();
@@ -194,5 +144,6 @@
 	    instructions.setWrapStyleWord(true);
 
-	    CheckList collection_checklist = new CheckList(collection_checklist_model);
+	    collection_checklist = new CheckList(collection_checklist_model);
+
 	    // Layout
 	    //center_pane.setTopComponent(new JScrollPane(instructions));
@@ -209,12 +160,74 @@
 	}
 
-	public void paint(Graphics g) {
-	    super.paint(g);
-	    // If this is the first time we've painted this control, then set the divider 1/3:2/3
-	    //if(init) {
-	    //	init = false;
-	    //	center_pane.setDividerLocation(0.3);
-	    //	super.paint(g);
-	    //}
+	public void destroy() {
+	}
+
+	public void gainFocus() {
+	}
+
+	public void loseFocus() {
+	    // Retrieve the current supercollections
+	    ArrayList supercollections = children();
+	    // Now iterate through the checklist, and for each checked box found ensure the Supercollection exists, and ensure its assigned. Remove any supercollections altered in this way from the temporary array list
+	    int size = collection_checklist_model.size();
+	    for(int i = 0; i < size; i++) {
+		Entry entry = (Entry) collection_checklist_model.get(i);
+		if(entry.isSelected()) {
+		    String collection_name = (String) entry.getProperty();
+		    SuperCollection supercollection = getSuperCollection(collection_name);
+		    // Create the supercollection element if necessary
+		    if(supercollection == null) {
+			Element supercollection_element = root.getOwnerDocument().createElement(StaticStrings.COLLECTION_ELEMENT);
+			supercollection = new SuperCollection(supercollection_element);
+			supercollection.setName(collection_name);
+			addSuperCollection(supercollection);
+		    }
+		    else {
+			supercollections.remove(supercollection);
+		    }
+		    supercollection.setAssigned(true);
+		}
+	    }
+	    // Any collections left in the temporary list have been unselected, so delete them
+	    for(int j = supercollections.size(); j > 0; j--) {
+		SuperCollection supercollection = (SuperCollection) supercollections.get(j - 1);
+		removeSuperCollection(supercollection);
+	    } 
+	}
+
+	private void buildModel() {
+	    // We start by building a model of the installed collections.
+	    collection_checklist_model = new ArrayList();
+	    File gsdl_collection_directory = new File(Utility.getCollectionDir(Gatherer.config.gsdl_path));
+	    current_coll_name = Gatherer.c_man.getCollection().getName();
+	    File[] possible_collections = gsdl_collection_directory.listFiles();
+	    for(int i = 0; possible_collections != null && i < possible_collections.length; i++) {
+		// The simpliest case is if the directory etc/collect.cfg file and a metadata/ in it. Thus it can easily be built upon.
+		File collect_cfg_file = new File(possible_collections[i], Utility.CONFIG_DIR);
+		if(collect_cfg_file.exists()) {
+		    CollectionConfiguration collect_cfg = new CollectionConfiguration(collect_cfg_file);
+		    String collection_title = collect_cfg.getName();
+		    String collection_name = possible_collections[i].getName();
+		    // We do have to block the model collection.
+		    if(!collection_title.equals("**title**")) {
+			Entry entry = new Entry(collection_title);
+			entry.setProperty(collection_name);
+			// Check if a collection with this name exists. The current collection is always selected.
+			entry.setSelected(getSuperCollection(collection_name) != null || collection_name.equals(current_coll_name));
+			entry.setFixed(collection_name.equals(current_coll_name));
+			collection_checklist_model.add(entry);
+			entry = null;
+			
+		    }
+		    collection_name = null;
+		    collection_title = null;
+		    collect_cfg = null;
+		}
+		collect_cfg_file = null;
+	    }
+	    possible_collections = null;
+	    gsdl_collection_directory = null;
+	    // Sort the result.
+	    Collections.sort(collection_checklist_model);
 	}
     }
